.SH "NEXTSTEP DIFFERENCES"
NEXTSTEP v.0.4 of TOP  -  2/22/1996 tpugh
.br
The NEXTSTEP port includes reports on the number of threads per process which appears under the heading "THR".
.PP
The field "%WCPU" has been removed until we can figure out how to calculate the weighted CPU time with the given process information.
.PP
Memory statistics show the total RAM for the system, and the number of active, inactive, wired, and free Mach virtual memory pages (in bytes).  Also shown is the number of bytes moving into and out of virtual memory. 
.PP
The NEXTSTEP port was written by Tim Pugh <tpugh@oce.orst.edu>.
.PP
.SH COMPATIBILITY - next32
.br
This is the machine-dependent module for NEXTSTEP v3.x
.br
Reported to work for NEXTSTEP v3.0, v3.2, and v3.3 Mach OS:
.br
	NEXTSTEP v3.0 on Motorola machines.
.br
	NEXTSTEP v3.2 on Intel and Motorola machines.
.br
	NEXTSTEP v3.3 on Intel and Motorola machines.
.br
Problem with command column for (Choose next40 for fix):
.br
	NEXTSTEP v3.2 on HP machines.
.br
	NEXTSTEP v3.3 on HP and Sparc machines.
.br
Has not been tested for NEXTSTEP v2.x machines, although it should work.
.br
Has not been tested for NEXTSTEP v3.1 machines, although it should work.
.PP
.SH COMPATIBILITY - next40
.br
This is the machine-dependent module for NEXTSTEP v3.x/4.x
.br
Reported to work for:
.br
	NEXTSTEP v3.2 on HP machines.
.br
	NEXTSTEP v3.3 on HP and Sparc machines.
.br
Has not been tested for NEXTSTEP v4.0 machines, although it should work.
.PP
.SH HISTORY
.br
* 9/8/95  tpugh.  Removed the %WCPU field, no support for it.
.br
* 9/8/95  tpugh.  Removed all C++ style comments from machine.c to be
ANSI C compatible.
.br
* 2/13/96 tpugh.  Fixed command name display problem for hppa and sparc machines,and NS4.0 alpha machines. NeXT changed the task structure, so top could not find utask structure.  <mach/task.h> is not shipped with any NEXTSTEP system.
.br
* 2/14/96 tpugh.  Reduced line length to less than 80 columns.  Some commands are long and will extend beyond 80 colums.
.br
* 2/14/96 tpugh.  Fixed "top -U" fails with bus error.  In special cases where only a specific user is displayed, the process index variable was being improperly advanced, resulting in invalid process addresses and bus errors.
.br
* 2/14/96 tpugh.  Eliminated the text artifact in the command column.
.br
* 2/22/96 tpugh. Fixed problem with quiting the program.  When quiting the program, a message "nobody" was printed and the cursor was not placed at the bottom of the screen.  The hash_table was corrupting memory when hashit(uid=-2) = -2 or any negative number.
.br
* 2/22/96 tpugh.  Fixed incorrect load average display.  Incorrect scaling of the kernel load average fixed-point values.
.PP
.SH FREQUENTLY ASKED QUESTIONS
.br
#1:  top 3.3 (after configuring for next32 with all defaults) on my i386 running NEXTSTEP 3.3, I get:
.br
Error calling task_by_unix_pid(): failure(5)
.PP
Answer:
.br
The call is failing due to TOP file permission problems.  The user must be the superuser, root, or the program must have root privileges to work properly.  So install "top" with the permissions 4755.  Setting the group sticky bit for kmem does not work, because TOP needs to communicate with the Mach kernal for task and thread info, which requires root privileges.
.PP
As root, do the following:
.br
hostname# chown root.kmem top
.br
hostname# chmod 4755 top
.br
hostname# ls -lg top
.br
-rwsr-xr-x  1 root     kmem      121408 Sep  1 10:14 top*
.PP
#2:  How to compile top to create a multiple architecture binary file?
.PP
Answer:
.br
Add the -arch flags to the Makefile.  Due to the task.h file differences between (m68k,Intel) and (sparc,hppa) NEXTSTEP 3.x operating systems, a single binary file can not be generated.
.br
Change line 61 to:
.br
	CDEFS = -O -arch m68k -arch i386 -arch hppa -arch sparc
.PP
Add $(CFLAGS) to link command.  Change line 79 to:
.br
	$(CC) $(CFLAGS) -o top $(OBJS) -ltermcap -lm $(LIBS)
.PP
#3:  I installed 'top' chmod 4711, chown root.kmem, but cannot use the '-q' 
flag unless I am logged in as 'root'
.br
"top: warning: `-q' option can only be used by root"
.br
This seems to indicate that the setuid to root isn't being recognized 
correctly.
.PP
Answer:
.br
In order to run top with the "-q" command, top currently requires the user to be logged in a root because top checks the uid of the user logged in, not the effective uid of the file. Why?  To not allow regular users to swamp the system with a high-priority process. Imagine what a regular user could do with "top -q -s0 all"!
.PP
